package com.xjrsoft.module.room.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.github.yulichang.base.MPJBaseService;
import com.xjrsoft.module.room.dto.DistributeClassPageDto;
import com.xjrsoft.module.room.dto.DistributeRoomBedDto;
import com.xjrsoft.module.room.dto.DistributeRoomBedPageDto;
import com.xjrsoft.module.room.dto.RoomBedPageDto;
import com.xjrsoft.module.room.entity.RoomBed;
import com.xjrsoft.module.room.vo.DistributeClassPageVo;
import com.xjrsoft.module.room.vo.DistributeResultClassVo;
import com.xjrsoft.module.room.vo.DistributeResultListVo;
import com.xjrsoft.module.room.vo.DistributeRoomBedPageVo;
import com.xjrsoft.module.room.vo.RoomBedPageVo;

import java.util.List;

/**
* @title: 寝室床位
* @Author dzx
* @Date: 2023-12-27
* @Version 1.0
*/

public interface IRoomBedService extends MPJBaseService<RoomBed> {

    /**
     * 分页查询
     * @param page
     * @param dto
     * @return
     */
    Page<RoomBedPageVo> getPage(Page<RoomBedPageVo> page, RoomBedPageDto dto);


    Boolean clearStudentInfo(List<Long> ids);

    /**
     * 分配床位，第一步查询班级
     * @param page
     * @param dto
     * @return
     */
    Page<DistributeClassPageVo> getDistributeClassInfo(Page<DistributeClassPageVo> page, DistributeClassPageDto dto);

    /**
     * 分配床位，第二步查询班级
     * @param page
     * @param dto
     * @return
     */
    Page<DistributeRoomBedPageVo> getDistributeRoomBedInfo(Page<DistributeRoomBedPageVo> page, DistributeRoomBedPageDto dto);

    Boolean distributeRoomBed(DistributeRoomBedDto dto);

    /**
     * 返回分配的结果
     * @param dto
     * @return
     */
    List<DistributeResultClassVo> getDistributeResult(DistributeRoomBedDto dto);

}
